#ifndef  CLIB_DISKFONT_PROTOS_H
#define  CLIB_DISKFONT_PROTOS_H

#ifndef  DOS_DOS_H
#include <dos/dos.h>
#endif
#ifndef  DISKFONT_DISKFONT_H
#include <diskfont/diskfont.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif



struct TextFont *OpenDiskFont(struct TextAttr*);


#ifdef __IGNORE_NOT_SUPPORTED__

  LONG AvailFonts(STRPTR,long,long);
  struct FontContentsHeader *NewFontContents(BPTR,STRPTR);
  void DisposeFontContents(struct FontContentsHeader*);
  struct DiskFont *NewScaledDiskFont( struct TextFont*,struct TextAttr*);

#else  /** __IGNORE_NOT_SUPPORTED__ **/

#define AvailFonts AvailFonts_NOT_SUPPORTED
  LONG AvailFonts(struct NOT_SUPPORTED*,STRPTR,long,long);

#define FontContentsHeader FontContentsHeader_NOT_SUPPORTED
  struct FontContentsHeader *NewFontContents(struct NOT_SUPPORTED*,BPTR,STRPTR);

#define DisposeFontContents DisposeFontContents_NOT_SUPPORTED
  void DisposeFontContents(struct NOT_SUPPORTED*,struct FontContentsHeader*);

#define DiskFont DiskFont_NOT_SUPPORTED
  struct DiskFont *NewScaledDiskFont(struct NOT_SUPPORTED*,struct TextFont*,struct TextAttr*);

#endif /** __IGNORE_NOT_SUPPORTED__ **/


#ifdef __cplusplus
}
#endif


#endif	 /* CLIB_DISKFONT_PROTOS_H */
