#ifndef  CLIB_GRAPHICS_PROTOS_H
#define  CLIB_GRAPHICS_PROTOS_H

#ifndef  GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif
#ifndef  GRAPHICS_DISPLAYINFO_H
#include <graphics/displayinfo.h>
#endif
#ifndef  GRAPHICS_GELS_H
//#include <graphics/gels.h>
#endif
#ifndef  GRAPHICS_RASTPORT_H
#include <graphics/rastport.h>
#endif
#ifndef  GRAPHICS_VIEW_H
#include <graphics/view.h>
#endif
#ifndef  GRAPHICS_COPPER_H
//#include <graphics/copper.h>
#endif
#ifndef  GRAPHICS_CLIP_H
#include <graphics/clip.h>
#endif
#ifndef  GRAPHICS_REGIONS_H
#include <graphics/regions.h>
#endif
#ifndef  GRAPHICS_SPRITE_H
//#include <graphics/sprite.h>
#endif
#ifndef  GRAPHICS_TEXT_H
#include <graphics/text.h>
#endif
#ifndef  HARDWARE_BLIT_H
//#include <hardware/blit.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

// *** Spezial-Funktionen
struct ColorMap* GetColorMapViewPort(struct ViewPort* vp);



LONG BltBitMap( struct BitMap *srcBitMap, long xSrc, long ySrc,
	struct BitMap *destBitMap, long xDest, long yDest, long xSize,
	long ySize, unsigned long minterm, unsigned long mask,
	PLANEPTR tempA );
void BltTemplate( PLANEPTR source, long xSrc, long srcMod,
	struct RastPort *destRP, long xDest, long yDest, long xSize,
	long ySize );
WORD TextLength( struct RastPort *rp, STRPTR string, unsigned long count );
VOID Text( struct RastPort *rp, STRPTR string, unsigned long count );
VOID SetFont( struct RastPort *rp, struct TextFont *textFont );
struct TextFont *OpenFont( struct TextAttr *textAttr );
void CloseFont( struct TextFont *textFont );
ULONG AskSoftStyle( struct RastPort *rp );
ULONG SetSoftStyle( struct RastPort *rp, unsigned long style,
	unsigned long enable );
void InitRastPort( struct RastPort *rp );
void SetRast( struct RastPort *rp, unsigned long pen );
void Move( struct RastPort *rp, long x, long y );
void Draw( struct RastPort *rp, long x, long y );
void RectFill( struct RastPort *rp, long xMin, long yMin, long xMax,long yMax );
void BltPattern( struct RastPort *rp, PLANEPTR mask, long xMin, long yMin,
	long xMax, long yMax, unsigned long maskBPR );
ULONG ReadPixel( struct RastPort *rp, long x, long y );
VOID WritePixel( struct RastPort *rp, long x, long y );
void PolyDraw( struct RastPort *rp, long count, WORD *polyTable );
void SetAPen( struct RastPort *rp, unsigned long pen );
void SetBPen( struct RastPort *rp, unsigned long pen );
void SetDrMd( struct RastPort *rp, unsigned long drawMode );
void InitBitMap( struct BitMap *bitMap,ULONG depth,ULONG width,ULONG height );
void ScrollRaster(struct RastPort *rp,long dx,long dy,long xMin,long yMin,long xMax,long yMax);
void LockLayerRom( struct Layer *layer );
void UnlockLayerRom( struct Layer *layer );
void SyncSBitMap( struct Layer *layer );
void CopySBitMap( struct Layer *layer );
void AddFont( struct TextFont *textFont );
void RemFont( struct TextFont *textFont );
void AndRectRegion( struct Region *region, struct Rectangle *rectangle );
BOOL OrRectRegion( struct Region *region, struct Rectangle *rectangle );
struct Region *NewRegion( void );
BOOL ClearRectRegion( struct Region *region, struct Rectangle *rectangle );
void ClearRegion( struct Region *region );
void DisposeRegion( struct Region *region );
void ClipBlit( struct RastPort *srcRP, long xSrc, long ySrc,
	struct RastPort *destRP, long xDest, long yDest, long xSize,
	long ySize, unsigned long minterm );
BOOL XorRectRegion( struct Region *region, struct Rectangle *rectangle );
struct ColorMap *GetColorMap( long entries );
void FreeColorMap( struct ColorMap *colorMap );
void BltBitMapRastPort( struct BitMap *srcBitMap, long xSrc, long ySrc,
	struct RastPort *destRP, long xDest, long yDest, long xSize,
	long ySize, unsigned long minterm );
BOOL OrRegionRegion( struct Region *srcRegion, struct Region *destRegion );
BOOL XorRegionRegion( struct Region *srcRegion, struct Region *destRegion );
BOOL AndRegionRegion( struct Region *srcRegion, struct Region *destRegion );
void SetRGB4CM( struct ColorMap *colorMap,ULONG index,ULONG red,ULONG green,ULONG blue );
void BltMaskBitMapRastPort( struct BitMap *srcBitMap, long xSrc, long ySrc,
	struct RastPort *destRP, long xDest, long yDest, long xSize,
	long ySize, unsigned long minterm, PLANEPTR bltMask );
BOOL AttemptLockLayerRom( struct Layer *layer );
void EraseRect( struct RastPort *rp, long xMin, long yMin, long xMax,long yMax );
LONG ObtainBestPenA( struct ColorMap *cm, unsigned long r, unsigned long g,
	unsigned long b, struct TagItem *tags );
LONG ObtainBestPen( struct ColorMap *cm, unsigned long r, unsigned long g,
	unsigned long b, unsigned long tag1Type, ... );
void SetRGB32( struct ViewPort *vp, unsigned long n, unsigned long r,
	unsigned long g, unsigned long b );
void SetABPenDrMd( struct RastPort *rp, unsigned long apen, unsigned long bpen,
	unsigned long drawmode );
void GetRGB32( struct ColorMap *cm, unsigned long firstcolor,
	unsigned long ncolors, ULONG *table );
struct BitMap *AllocBitMap( unsigned long sizex, unsigned long sizey,
	unsigned long depth, unsigned long flags,
	struct BitMap *friend_bitmap );
void FreeBitMap( struct BitMap *bm );
void ReleasePen( struct ColorMap *cm, unsigned long n );
ULONG ObtainPen( struct ColorMap *cm,ULONG n,ULONG r,ULONG g,ULONG b,ULONG f );
ULONG GetBitMapAttr( struct BitMap *bm, unsigned long attrnum );
ULONG SetOutlinePen( struct RastPort *rp, unsigned long pen );
void SetRGB32CM( struct ColorMap *cm,ULONG n,ULONG r,ULONG g,ULONG b );
void ScrollRasterBF( struct RastPort *rp, long dx, long dy, long xMin,
	long yMin, long xMax, long yMax );
void SetRPAttrsA( struct RastPort *rp, struct TagItem *tags );
void SetRPAttrs( struct RastPort *rp, unsigned long tag1Type, ... );
void GetRPAttrsA( struct RastPort *rp, struct TagItem *tags );
void GetRPAttrs( struct RastPort *rp, unsigned long tag1Type, ... );

ULONG GetDisplayInfoData(APTR handle, UBYTE *buf, ULONG size, ULONG type, ULONG id);
LONG GetVPModeID( struct ViewPort *vp );
ULONG TextFit(struct RastPort *rp,STRPTR string, ULONG length, struct TextExtent *textextent, struct TextExtent *rectextent, LONG direction, ULONG rectwidth, ULONG recthight);
WORD TextExtent(struct RastPort *rp, STRPTR string, LONG length, struct TextExtent *textextent);
ULONG GetAPen( struct RastPort *rp );
ULONG GetBPen( struct RastPort *rp );
ULONG GetOutlinePen( struct RastPort *rp );
void SetRGB4( struct ViewPort *vp,ULONG index,ULONG red,ULONG green,ULONG blue);
ULONG GetRGB4( struct ColorMap *colorMap, long entry );
void LoadRGB4( struct ViewPort *vp, UWORD *colors, long count );
LONG WritePixelArray8(struct RastPort*,ULONG,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
LONG WritePixelLine8(struct RastPort*,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
void WriteChunkyPixels(struct RastPort*,ULONG,ULONG,ULONG,ULONG,UBYTE*,long);

// ---------------




#ifdef __IGNORE_NOT_SUPPORTED__

  ULONG GetDrMd( struct RastPort *rp );
  void LoadRGB32( struct ViewPort *vp, ULONG *table );

  void ClearEOL( struct RastPort *rp );
  void ClearScreen( struct RastPort *rp );
  void AddBob( struct Bob *bob, struct RastPort *rp );
  void AddVSprite( struct VSprite *vSprite, struct RastPort *rp );
  void DoCollision( struct RastPort *rp );
  void DrawGList( struct RastPort *rp, struct ViewPort *vp );
  void InitGels(struct VSprite*,struct VSprite*,struct GelsInfo*);
  void InitMasks( struct VSprite *vSprite );
  void RemIBob( struct Bob *bob, struct RastPort *rp, struct ViewPort *vp );
  void RemVSprite( struct VSprite *vSprite );
  void SetCollision(ULONG num,APTR,struct GelsInfo*);
  void SortGList( struct RastPort *rp );
  void AddAnimOb(struct AnimOb*,struct AnimOb**,struct RastPort*);
  void Animate( struct AnimOb **anKey, struct RastPort *rp );
  BOOL GetGBuffers( struct AnimOb *anOb, struct RastPort *rp, long flag );
  void InitGMasks( struct AnimOb *anOb );
  void DrawEllipse(struct RastPort *rp,long xCenter,long yCenter,long a,long b);
  LONG AreaEllipse(struct RastPort *rp,long xCenter,long yCenter,long a,long b);
  void InitVPort( struct ViewPort *vp );
  ULONG MrgCop( struct View *view );
  ULONG MakeVPort( struct View *view, struct ViewPort *vp );
  void LoadView( struct View *view );
  void WaitBlit( void );
  LONG AreaMove( struct RastPort *rp, long x, long y );
  LONG AreaDraw( struct RastPort *rp, long x, long y );
  LONG AreaEnd( struct RastPort *rp );
  void WaitTOF( void );
  void QBlit( struct bltnode *blit );
  void InitArea( struct AreaInfo *areaInfo, APTR vectorBuffer,long maxVectors );
  void QBSBlit( struct bltnode *blit );
  void BltClear( PLANEPTR memBlock, unsigned long byteCount,ULONG flags );
  BOOL Flood( struct RastPort *rp, unsigned long mode, long x, long y );
  void InitView( struct View *view );
  void CBump( struct UCopList *copList );
  void CMove( struct UCopList *copList, APTR destination, long data );
  void CWait( struct UCopList *copList, long v, long h );
  LONG VBeamPos( void );
  void WaitBOVP( struct ViewPort *vp );
  WORD GetSprite( struct SimpleSprite *sprite, long num );
  void FreeSprite( long num );
  void ChangeSprite( struct ViewPort*,struct SimpleSprite*,PLANEPTR);
  void MoveSprite(struct ViewPort*,struct SimpleSprite*,long x,long y);
  void OwnBlitter( void );
  void DisownBlitter( void );
  struct TmpRas *InitTmpRas(struct TmpRas*,PLANEPTR buffer,long size);
  void AskFont( struct RastPort *rp, struct TextAttr *textAttr );
  PLANEPTR AllocRaster( unsigned long width, unsigned long height );
  void FreeRaster( PLANEPTR p, unsigned long width, unsigned long height );
  void FreeVPortCopLists( struct ViewPort *vp );
  void FreeCopList( struct CopList *copList );
  void FreeCprList( struct cprlist *cprList );
  void ScrollVPort( struct ViewPort *vp );
  struct CopList *UCopperListInit( struct UCopList *uCopList, long n );
  void FreeGBuffers( struct AnimOb *anOb, struct RastPort *rp, long flag );
  APTR GfxNew( unsigned long gfxNodeType );
  void GfxFree( APTR gfxNodePtr );
  void GfxAssociate( APTR associateNode, APTR gfxNodePtr );
  void BitMapScale( struct BitScaleArgs *bitScaleArgs );
  UWORD ScalerDiv(ULONG factor,ULONG numerator,ULONG denominator );
  APTR GfxLookUp( APTR associateNode );
  BOOL VideoControl( struct ColorMap *colorMap, struct TagItem *tagarray );
  BOOL VideoControlTags( struct ColorMap *colorMap,ULONG tag1Type,... );
  struct MonitorSpec *OpenMonitor( STRPTR monitorName,ULONG displayID );
  BOOL CloseMonitor( struct MonitorSpec *monitorSpec );
  APTR FindDisplayInfo( unsigned long displayID );
  ULONG NextDisplayInfo( unsigned long displayID );
  void FontExtent( struct TextFont *font, struct TextExtent *fontExtent );
  LONG ReadPixelLine8(struct RastPort*,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
  LONG ReadPixelArray8(struct RastPort*,ULONG,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
  LONG ModeNotAvailable( unsigned long modeID );
  WORD WeighTAMatch(struct TextAttr*,struct TextAttr*,struct TagItem*);
  WORD WeighTAMatchTags(struct TextAttr*,struct TextAttr*,ULONG, ... );
  ULONG ExtendFont( struct TextFont *font, struct TagItem *fontTags );
  ULONG ExtendFontTags( struct TextFont *font, unsigned long tag1Type, ... );
  void StripFont( struct TextFont *font );
  UWORD CalcIVG( struct View *v, struct ViewPort *vp );
  LONG AttachPalExtra( struct ColorMap *cm, struct ViewPort *vp );
  ULONG SetChipRev( unsigned long want );
  LONG GetExtSpriteA( struct ExtSprite *ss, struct TagItem *tags );
  LONG GetExtSprite( struct ExtSprite *ss, unsigned long tag1Type, ... );
  ULONG CoerceMode( struct ViewPort *vp,ULONG monitorid,ULONG flags );
  void ChangeVPBitMap(struct ViewPort *vp,struct BitMap *bm,struct DBufInfo *db);
  struct DBufInfo *AllocDBufInfo( struct ViewPort *vp );
  void FreeDBufInfo( struct DBufInfo *dbi );
  ULONG SetWriteMask( struct RastPort *rp, unsigned long msk );
  void SetMaxPen( struct RastPort *rp, unsigned long maxpen );
  LONG FindColor( struct ColorMap *cm,ULONG r,ULONG g,ULONG b,long maxcolor );
  struct ExtSprite *AllocSpriteDataA( struct BitMap *bm, struct TagItem *tags );
  struct ExtSprite *AllocSpriteData( struct BitMap *bm,ULONG tag1Type,... );
  LONG ChangeExtSpriteA(struct ViewPort*,struct ExtSprite*,struct ExtSprite*,struct TagItem*);
  LONG ChangeExtSprite(struct ViewPort*,struct ExtSprite*,struct ExtSprite*,ULONG tag1Type, ... );
  void FreeSpriteData( struct ExtSprite *sp );
  ULONG BestModeIDA( struct TagItem *tags );
  ULONG BestModeID( unsigned long tag1Type, ... );

#else  /** __IGNORE_NOT_SUPPORTED__ **/

#define LoadRGB32 LoadRGB32_NOT_SUPPORTED
  void LoadRGB32(struct NOT_SUPPORTED*, struct ViewPort *vp, ULONG *table );

#define ClearEOL ClearEOL_NOT_SUPPORTED
  void ClearEOL(struct NOT_SUPPORTED*, struct RastPort *rp );
#define ClearScreen ClearScreen_NOT_SUPPORTED
  void ClearScreen(struct NOT_SUPPORTED*, struct RastPort *rp );
#define AddBob AddBob_NOT_SUPPORTED
  void AddBob(struct NOT_SUPPORTED*, struct Bob *bob, struct RastPort *rp );
#define AddVSprite AddVSprite_NOT_SUPPORTED
  void AddVSprite(struct NOT_SUPPORTED*, struct VSprite *vSprite, struct RastPort *rp );
#define DoCollision DoCollision_NOT_SUPPORTED
  void DoCollision(struct NOT_SUPPORTED*, struct RastPort *rp );
#define DrawGList DrawGList_NOT_SUPPORTED
  void DrawGList(struct NOT_SUPPORTED*, struct RastPort *rp, struct ViewPort *vp );
#define InitGels InitGels_NOT_SUPPORTED
  void InitGels(struct NOT_SUPPORTED*,struct VSprite*,struct VSprite*,struct GelsInfo*);
#define InitMasks InitMasks_NOT_SUPPORTED
  void InitMasks(struct NOT_SUPPORTED*, struct VSprite *vSprite );
#define RemIBob RemIBob_NOT_SUPPORTED
  void RemIBob(struct NOT_SUPPORTED*, struct Bob *bob, struct RastPort *rp, struct ViewPort *vp );
#define RemVSprite RemVSprite_NOT_SUPPORTED
  void RemVSprite(struct NOT_SUPPORTED*, struct VSprite *vSprite );
#define SetCollision SetCollision_NOT_COMPATIBLE
  void SetCollision(struct NOT_SUPPORTED*,ULONG num,APTR,struct GelsInfo*);
#define SortGList SortGList_NOT_COMPATIBLE
  void SortGList(struct NOT_SUPPORTED*, struct RastPort *rp );
#define AddAnimOb AddAnimOb_NOT_COMPATIBLE
  void AddAnimOb(struct NOT_SUPPORTED*,struct AnimOb*,struct AnimOb**,struct RastPort*);
#define Animate Animate_NOT_COMPATIBLE
  void Animate(struct NOT_SUPPORTED*, struct AnimOb **anKey, struct RastPort *rp );
#define GetGBuffers GetGBuffers_NOT_COMPATIBLE
  BOOL GetGBuffers(struct NOT_SUPPORTED*, struct AnimOb *anOb, struct RastPort *rp, long flag );
#define InitGMasks InitGMasks_NOT_COMPATIBLE
  void InitGMasks(struct NOT_SUPPORTED*, struct AnimOb *anOb );
#define DrawEllipse DrawEllipse_NOT_SUPPORTED
  void DrawEllipse(struct NOT_SUPPORTED*,struct RastPort *rp,long xCenter,long yCenter,long a,long b);
#define AreaEllipse AreaEllipse_NOT_SUPPORTED
  LONG AreaEllipse(struct NOT_SUPPORTED*,struct RastPort *rp,long xCenter,long yCenter,long a,long b);
#define InitVPort InitVPort_NOT_COMPATIBLE
  void InitVPort(struct NOT_SUPPORTED*, struct ViewPort *vp );
#define MrgCop MrgCop_NOT_COMPATIBLE
  ULONG MrgCop(struct NOT_SUPPORTED*, struct View *view );
#define MakeVPort MakeVPort_NOT_COMPATIBLE
  ULONG MakeVPort(struct NOT_SUPPORTED*, struct View *view, struct ViewPort *vp );
#define LoadView LoadView_NOT_COMPATIBLE
  void LoadView(struct NOT_SUPPORTED*, struct View *view );
#define WaitBlit WaitBlit_NOT_COMPATIBLE
  void WaitBlit(struct NOT_SUPPORTED*);
#define AreaMove AreaMove_NOT_SUPPORTED
  LONG AreaMove(struct NOT_SUPPORTED*, struct RastPort *rp, long x, long y );
#define AreaDraw AreaDraw_NOT_SUPPORTED
  LONG AreaDraw(struct NOT_SUPPORTED*, struct RastPort *rp, long x, long y );
#define AreaEnd AreaEnd_NOT_SUPPORTED
  LONG AreaEnd(struct NOT_SUPPORTED*, struct RastPort *rp );
#define WaitTOF WaitTOF_NOT_COMPATIBLE
  void WaitTOF(struct NOT_SUPPORTED*);
#define QBlit QBlit_NOT_COMPATIBLE
  void QBlit(struct NOT_SUPPORTED*, struct bltnode *blit );
#define InitArea InitArea_NOT_SUPPORTED
  void InitArea(struct NOT_SUPPORTED*, struct AreaInfo *areaInfo, APTR vectorBuffer,long maxVectors );
#define QBSBlit QBSBlit_NOT_COMPATIBLE
  void QBSBlit(struct NOT_SUPPORTED*, struct bltnode *blit );
#define BltClear BltClear_NOT_COMPATIBLE
  void BltClear(struct NOT_SUPPORTED*, PLANEPTR memBlock, unsigned long byteCount,ULONG flags );
#define Flood Flood_NOT_SUPPORTED
  BOOL Flood(struct NOT_SUPPORTED*, struct RastPort *rp, unsigned long mode, long x, long y );
#define InitView InitView_NOT_COMPATIBLE
  void InitView(struct NOT_SUPPORTED*, struct View *view );
#define CBump CBump_NOT_SUPPORTED
  void CBump(struct NOT_SUPPORTED*, struct UCopList *copList );
#define CMove CMove_NOT_SUPPORTED
  void CMove(struct NOT_SUPPORTED*, struct UCopList *copList, APTR destination, long data );
#define CWait CWait_NOT_SUPPORTED
  void CWait(struct NOT_SUPPORTED*, struct UCopList *copList, long v, long h );
#define VBeamPos VBeamPos_NOT_SUPPORTED
  LONG VBeamPos(struct NOT_SUPPORTED*);
#define WaitBOVP WaitBOVP_NOT_COMPATIBLE
  void WaitBOVP(struct NOT_SUPPORTED*, struct ViewPort *vp );
#define GetSprite GetSprite_NOT_SUPPORTED
  WORD GetSprite(struct NOT_SUPPORTED*, struct SimpleSprite *sprite, long num );
#define FreeSprite FreeSprite_NOT_SUPPORTED
  void FreeSprite(struct NOT_SUPPORTED*, long num );
#define ChangeSprite ChangeSprite_NOT_SUPPORTED
  void ChangeSprite(struct NOT_SUPPORTED*, struct ViewPort*,struct SimpleSprite*,PLANEPTR);
#define MoveSprite MoveSprite_NOT_SUPPORTED
  void MoveSprite(struct NOT_SUPPORTED*,struct ViewPort*,struct SimpleSprite*,long x,long y);
#define OwnBlitter OwnBlitter_NOT_COMPATIBLE
  void OwnBlitter(struct NOT_SUPPORTED*);
#define DisownBlitter DisownBlitter_NOT_COMPATIBLE
  void DisownBlitter(struct NOT_SUPPORTED*);
#define InitTmpRas InitTmpRas_NOT_SUPPORTED
  struct TmpRas *InitTmpRas(struct NOT_SUPPORTED*,struct TmpRas*,PLANEPTR buffer,long size);
#define AskFont AskFont_NOT_COMPATIBLE
  void AskFont(struct NOT_SUPPORTED*, struct RastPort *rp, struct TextAttr *textAttr );
#define AllocRaster AllocRaster_NOT_COMPATIBLE
  PLANEPTR AllocRaster(struct NOT_SUPPORTED*, unsigned long width, unsigned long height );
#define FreeRaster FreeRaster_NOT_COMPATIBLE
  void FreeRaster(struct NOT_SUPPORTED*, PLANEPTR p, unsigned long width, unsigned long height );
#define FreeVPortCopLists FreeVPortCopLists_NOT_COMPATIBLE
  void FreeVPortCopLists(struct NOT_SUPPORTED*, struct ViewPort *vp );
#define FreeCopList FreeCopList_NOT_COMPATIBLE
  void FreeCopList(struct NOT_SUPPORTED*, struct CopList *copList );
#define FreeCprList FreeCprList_NOT_COMPATIBLE
  void FreeCprList(struct NOT_SUPPORTED*, struct cprlist *cprList );
#define ScrollVPort ScrollVPort_NOT_COMPATIBLE
  void ScrollVPort(struct NOT_SUPPORTED*, struct ViewPort *vp );
#define UCopperListInit UCopperListInit_NOT_COMPATIBLE
  struct CopList *UCopperListInit(struct NOT_SUPPORTED*, struct UCopList *uCopList, long n );
#define FreeGBuffers FreeGBuffers_NOT_SUPPORTED
  void FreeGBuffers(struct NOT_SUPPORTED*, struct AnimOb *anOb, struct RastPort *rp, long flag );
#define GfxNew GfxNew_NOT_COMPATIBLE
  APTR GfxNew(struct NOT_SUPPORTED*, unsigned long gfxNodeType );
#define GfxFree GfxFree_NOT_COMPATIBLE
  void GfxFree(struct NOT_SUPPORTED*, APTR gfxNodePtr );
#define GfxAssociate GfxAssociate_NOT_COMPATIBLE
  void GfxAssociate(struct NOT_SUPPORTED*, APTR associateNode, APTR gfxNodePtr );
#define BitMapScale BitMapScale_NOT_SUPPORTED
  void BitMapScale(struct NOT_SUPPORTED*, struct BitScaleArgs *bitScaleArgs );
#define ScalerDiv ScalerDiv_NOT_SUPPORTED
  UWORD ScalerDiv(struct NOT_SUPPORTED*,ULONG factor,ULONG numerator,ULONG denominator );
#define GfxLookUp GfxLookUp_NOT_COMPATIBLE
  APTR GfxLookUp(struct NOT_SUPPORTED*, APTR associateNode );
#define VideoControl VideoControl_NOT_SUPPORTED
  BOOL VideoControl(struct NOT_SUPPORTED*, struct ColorMap *colorMap, struct TagItem *tagarray );
#define VideoControlTags VideoControlTags_NOT_SUPPORTED
  BOOL VideoControlTags(struct NOT_SUPPORTED*, struct ColorMap *colorMap,ULONG tag1Type,... );
#define OpenMonitor OpenMonitor_NOT_COMPATIBLE
  struct MonitorSpec *OpenMonitor(struct NOT_SUPPORTED*, STRPTR monitorName,ULONG displayID );
#define CloseMonitor CloseMonitor_NOT_COMPATIBLE
  BOOL CloseMonitor(struct NOT_SUPPORTED*, struct MonitorSpec *monitorSpec );
#define FindDisplayInfo FindDisplayInfo_NOT_COMPATIBLE
  DisplayInfoHandle FindDisplayInfo(struct NOT_SUPPORTED*, unsigned long displayID );
#define NextDisplayInfo NextDisplayInfo_NOT_COMPATIBLE
  ULONG NextDisplayInfo(struct NOT_SUPPORTED*, unsigned long displayID );
#define FontExtent FontExtent_NOT_SUPPORTED
  void FontExtent(struct NOT_SUPPORTED*, struct TextFont *font, struct TextExtent *fontExtent );
#define ReadPixelLine8 ReadPixelLine8_NOT_SUPPORTED
  LONG ReadPixelLine8(struct NOT_SUPPORTED*,struct RastPort*,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
#define ReadPixelArray8 ReadPixelArray8_NOT_SUPPORTED
  LONG ReadPixelArray8(struct NOT_SUPPORTED*,struct RastPort*,ULONG,ULONG,ULONG,ULONG,UBYTE*,struct RastPort*);
#define ModeNotAvailable ModeNotAvailable_NOT_SUPPORTED
  LONG ModeNotAvailable(struct NOT_SUPPORTED*, unsigned long modeID );
#define WeighTAMatch WeighTAMatch_NOT_SUPPORTED
  WORD WeighTAMatch(struct NOT_SUPPORTED*,struct TextAttr*,struct TextAttr*,struct TagItem*);
#define WeighTAMatchTags WeighTAMatchTags_NOT_SUPPORTED
  WORD WeighTAMatchTags(struct NOT_SUPPORTED*,struct TextAttr*,struct TextAttr*,ULONG, ... );
#define ExtendFont ExtendFont_NOT_SUPPORTED
  ULONG ExtendFont(struct NOT_SUPPORTED*, struct TextFont *font, struct TagItem *fontTags );
#define ExtendFontTags ExtendFontTags_NOT_SUPPORTED
  ULONG ExtendFontTags(struct NOT_SUPPORTED*, struct TextFont *font, unsigned long tag1Type, ... );
#define StripFont StripFont_NOT_SUPPORTED
  void StripFont(struct NOT_SUPPORTED*, struct TextFont *font );
#define CalcIVG CalcIVG_NOT_COMPATIBLE
  UWORD CalcIVG(struct NOT_SUPPORTED*, struct View *v, struct ViewPort *vp );
#define AttachPalExtra AttachPalExtra_NOT_COMPATIBLE
  LONG AttachPalExtra(struct NOT_SUPPORTED*, struct ColorMap *cm, struct ViewPort *vp );
#define SetChipRev SetChipRev_NOT_COMPATIBLE
  ULONG SetChipRev(struct NOT_SUPPORTED*, unsigned long want );
#define GetExtSpriteA GetExtSpriteA_NOT_COMPATIBLE
  LONG GetExtSpriteA(struct NOT_SUPPORTED*, struct ExtSprite *ss, struct TagItem *tags );
#define GetExtSprite GetExtSprite_NOT_COMPATIBLE
  LONG GetExtSprite(struct NOT_SUPPORTED*, struct ExtSprite *ss, unsigned long tag1Type, ... );
#define CoerceMode CoerceMode_NOT_COMPATIBLE
  ULONG CoerceMode(struct NOT_SUPPORTED*, struct ViewPort *vp,ULONG monitorid,ULONG flags );
#define ChangeVPBitMap ChangeVPBitMap_NOT_SUPPORTED
  void ChangeVPBitMap(struct NOT_SUPPORTED*,struct ViewPort *vp,struct BitMap *bm,struct DBufInfo *db);
#define AllocDBufInfo AllocDBufInfo_NOT_SUPPORTED
  struct DBufInfo *AllocDBufInfo(struct NOT_SUPPORTED*, struct ViewPort *vp );
#define FreeDBufInfo FreeDBufInfo_NOT_SUPPORTED
  void FreeDBufInfo(struct NOT_SUPPORTED*, struct DBufInfo *dbi );
#define SetWriteMask SetWriteMask_NOT_SUPPORTED
  ULONG SetWriteMask(struct NOT_SUPPORTED*, struct RastPort *rp, unsigned long msk );
#define SetMaxPen SetMaxPen_NOT_SUPPORTED
  void SetMaxPen(struct NOT_SUPPORTED*, struct RastPort *rp, unsigned long maxpen );
#define FindColor FindColor_NOT_SUPPORTED
  LONG FindColor(struct NOT_SUPPORTED*, struct ColorMap *cm,ULONG r,ULONG g,ULONG b,long maxcolor );
#define AllocSpriteDataA AllocSpriteDataA_NOT_SUPPORTED
  struct ExtSprite *AllocSpriteDataA(struct NOT_SUPPORTED*, struct BitMap *bm, struct TagItem *tags );
#define AllocSpriteData AllocSpriteData_NOT_SUPPORTED
  struct ExtSprite *AllocSpriteData(struct NOT_SUPPORTED*, struct BitMap *bm,ULONG tag1Type,... );
#define ChangeExtSpriteA ChangeExtSpriteA_NOT_SUPPORTED
  LONG ChangeExtSpriteA(struct NOT_SUPPORTED*,struct ViewPort*,struct ExtSprite*,struct ExtSprite*,struct TagItem*);
#define ChangeExtSprite ChangeExtSprite_NOT_SUPPORTED
  LONG ChangeExtSprite(struct NOT_SUPPORTED*,struct ViewPort*,struct ExtSprite*,struct ExtSprite*,ULONG tag1Type, ... );
#define FreeSpriteData FreeSpriteData_NOT_SUPPORTED
  void FreeSpriteData(struct NOT_SUPPORTED*, struct ExtSprite *sp );
#define BestModeIDA BestModeIDA_NOT_SUPPORTED
  ULONG BestModeIDA(struct NOT_SUPPORTED*, struct TagItem *tags );
#define BestModeID BestModeID_NOT_SUPPORTED
  ULONG BestModeID(struct NOT_SUPPORTED*, unsigned long tag1Type, ... );


#endif /** __IGNORE_NOT_SUPPORTED__ **/












#ifdef __cplusplus
}
#endif

#endif	 /* CLIB_GRAPHICS_PROTOS_H */
