#ifndef  CLIB_REXXSYSLIB_PROTOS_H
#define  CLIB_REXXSYSLIB_PROTOS_H

#ifndef  EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef  REXX_RXSLIB_H
#include <rexx/rxslib.h>
#endif
#ifndef  REXX_REXXIO_H
#include <rexx/rexxio.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


#ifdef __IGNORE_NOT_SUPPORTED__

  UBYTE *CreateArgstring( UBYTE *string, ULONG length );
  void DeleteArgstring( UBYTE *argstring );
  ULONG LengthArgstring( UBYTE *argstring );
  struct RexxMsg *CreateRexxMsg(struct MsgPort*,UBYTE *extension,UBYTE *host);
  void DeleteRexxMsg( struct RexxMsg *packet );
  void ClearRexxMsg( struct RexxMsg *msgptr, ULONG count );
  BOOL FillRexxMsg( struct RexxMsg *msgptr, ULONG count,ULONG mask );
  BOOL IsRexxMsg( struct RexxMsg *msgptr );
  void LockRexxBase( ULONG resource );
  void UnlockRexxBase( ULONG resource );

#else  /** __IGNORE_NOT_SUPPORTED__ **/

#define CreateArgstring CreateArgstring_NOT_SUPPORTED
  UBYTE *CreateArgstring(struct NOT_SUPPORTED*, UBYTE *string, ULONG length );
#define DeleteArgstring DeleteArgstring_NOT_SUPPORTED
  void DeleteArgstring(struct NOT_SUPPORTED*, UBYTE *argstring );
#define LengthArgstring LengthArgstring_NOT_SUPPORTED
  ULONG LengthArgstring(struct NOT_SUPPORTED*, UBYTE *argstring );
#define CreateRexxMsg CreateRexxMsg_NOT_SUPPORTED
  struct RexxMsg *CreateRexxMsg(struct NOT_SUPPORTED*,struct MsgPort*,UBYTE *extension,UBYTE *host);
#define DeleteRexxMsg DeleteRexxMsg_NOT_SUPPORTED
  void DeleteRexxMsg(struct NOT_SUPPORTED*, struct RexxMsg *packet );
#define ClearRexxMsg ClearRexxMsg_NOT_SUPPORTED
  void ClearRexxMsg(struct NOT_SUPPORTED*, struct RexxMsg *msgptr, ULONG count );
#define FillRexxMsg FillRexxMsg_NOT_SUPPORTED
  BOOL FillRexxMsg(struct NOT_SUPPORTED*, struct RexxMsg *msgptr, ULONG count,ULONG mask );
#define IsRexxMsg IsRexxMsg_NOT_SUPPORTED
  BOOL IsRexxMsg(struct NOT_SUPPORTED*, struct RexxMsg *msgptr );
#define LockRexxBase LockRexxBase_NOT_SUPPORTED
  void LockRexxBase(struct NOT_SUPPORTED*, ULONG resource );
#define UnlockRexxBase UnlockRexxBase_NOT_SUPPORTED
  void UnlockRexxBase(struct NOT_SUPPORTED*, ULONG resource );

#endif /** __IGNORE_NOT_SUPPORTED__ **/


#ifdef __cplusplus
}
#endif

#endif	 /* CLIB_REXXSYSLIB_PROTOS_H */
